Unit SF10R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF10_p;

function SF10R(X :Real; L :Integer; var IERR :Integer): Real;

implementation

function SF10R(X :Real; L :Integer; var IERR :Integer): Real;
var
I :Integer;
A,XX,X1,SUMF,SUMG,SUMP,SUMQ,TEMP :Real;
G :Array [0..2] of Real;
F :Array [0..3] of Real;
P :Array [0..4] of Real;
Q :Array [0..2] of Real;
PP :Array [0..8] of Real;
QQ :Array [0..8] of Real;
const
ONE :Real = 1.0E0;
ZERO :Real = 0.0E0;
SYS055 :Real = 1.2E-38;
CONST_ :Real = -1.159315E-01;
XMAX :Real = 43.39;
SYS073 :Real = 3.743392E-23;
SYS059 :Real = 3.4E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
{ Result -    SF10R  FORTRANe }
{   DATA  FORTRAN  }
P[0] := -3.272280E00;
P[1] := -5.135621E02;
P[2] := -2.547075E04;
P[3] := -3.562730E05;
P[4] := -1.492695E05;
Q[0] := -2.286836E02;
Q[1] := 2.532572E04;
Q[2] := -1.287567E06;
F[0] := -1.641445E00;
F[1] := -2.960166E02;
F[2] := -1.773378E04;
F[3] := -4.032034E05;
G[0] := -2.506497E02;
G[1] := 2.986571E04;
G[2] := -1.612814E06;
PP[0] := 1.030260E02;
PP[1] := 2.781557E03;
PP[2] := 1.927380E04;
PP[3] := 5.275924E04;
PP[4] := 6.786898E04;
PP[5] := 4.423446E04;
PP[6] := 1.477325E04;
PP[7] := 2.371139E03;
PP[8] := 1.427783E02;
QQ[0] := 1.723548E02;
QQ[1] := 3.220846E03;
QQ[2] := 1.893737E04;
QQ[3] := 4.746184E04;
QQ[4] := 5.801727E04;
QQ[5] := 3.667051E04;
QQ[6] := 1.201760E04;
QQ[7] := 1.906135E03;
QQ[8] := 1.139206E02;
IERR := 0;
if ( X <= ZERO ) 
 then goto _8;
A := ONE;
if ( L <> 1 ) and ( L <> 2 ) 
 then goto _10;
case L of
 1: goto _1;
 2: goto _2;
end;
_1:
if ( X > XMAX ) 
 then goto _9;
if ( X <= ONE ) 
 then goto _3;
A := Exp(-X);
goto _5;
_2:
if ( X > ONE ) 
 then goto _5;
A := Exp(X);
_3:
TEMP := Ln(X);
if ( X < SYS073 ) 
 then goto _4;
XX := X*X;
SUMP := (((P[0]*XX+P[1])*XX+P[2])*XX+P[3])*XX+P[4];
SUMQ := ((XX+Q[0])*XX+Q[1])*XX+Q[2];
SUMF := ((F[0]*XX+F[1])*XX+F[2])*XX+F[3];
SUMG := ((XX+G[0])*XX+G[1])*XX+G[2];
X1 := (SUMP/SUMQ-XX*SUMF*TEMP/SUMG-TEMP)*A;
Result := X1;
if ( X1 >= ONE ) 
 then Result := Result+SYS055;
goto _12;
_4:
Result := CONST_-TEMP;
goto _12;
_5:
XX := ONE/X;
SUMP := PP[0];
for I:=2 to 9 do
 begin
  SUMP := SUMP*XX+PP[I-1];
_6:
 end;
SUMQ := XX;
for I:=1 to 8 do
 begin
  SUMQ := (SUMQ+QQ[I-1])*XX;
_7:
 end;
SUMQ := SUMQ+QQ[8];
Result := SUMP/SUMQ/Sqrt(X)*A;
goto _12;
_8:
IERR := 66;
Result := SYS059;
goto _11;
_9:
Result := ZERO;
IERR := 67;
goto _11;
_10:
Result := SYS059;
IERR := 65;
_11:
UTSF10(IERR,10);
_12:
exit;
end;

end.
